Generator = require('./generators.js').Generator;
Semantic = require('./semantics.js').Semantic;
module.exports = {
  contexts: [{"who": "joe", "units": "dollars", "marker": "earn", "amount": 10, "period": "week"}, {"who": "joe", "units": "weekConcept", "duration": 15, "marker": "worked"}, {"who": "joe", "marker": "earn", "period": null, "units": "dollars", "amount": null, "isQuery": true}],
  objects: {           },
  expected: ["joe earns 10 dollars per week", "joe worked 15 weeks", "joe earned 150 dollars"],
  expected_semantics: [{"period": "week", "units": "dollars", "marker": "earn", "amount": 10, "who": "joe"}, {"who": "joe", "units": "weekConcept", "duration": 15, "marker": "worked"}, {"period": null, "amount": null, "who": "joe", "earnings": 150, "units": "dollars", "marker": "response", "isQuery": true}],
  generators: [
    new Generator( ({context}) => context.marker == 'earn', ({g, context}) => `${g(context.who)} earns ${g(context.amount)} ${g(context.units)} per ${context.period}` ),
    new Generator( ({context}) => context.marker == 'weekConcept' && context.duration == 1, ({g, context}) => `${context.duration} week` ),
    new Generator( ({context}) => context.marker == 'weekConcept' && context.duration > 1, ({g, context}) => `${context.duration} weeks` ),
    new Generator( ({context}) => context.marker == 'worked', ({g, context}) => `${g(context.who)} worked ${ g({ marker: context.units, duration: context.duration}) }` ),
    new Generator( ({context}) => context.marker == 'response', ({g, context}) => `${context.who} earned ${context.earnings} ${context.units}` ),
  ],
  semantics: [
    new Semantic( ({global, context}) => context.marker == 'earn' && context.isQuery, ({global, context}) => { context.marker = 'response'; context.earnings = global.earnings_per_period * global.number_of_time_units; context.units = global.units; } ),
    new Semantic( ({global, context}) => context.marker == 'earn', ({global, context}) => { global.who = context.who; global.earnings_per_period = context.amount; global.period = context.period; global.units = 'dollars'; } ),
    new Semantic( ({global, context}) => context.marker == 'worked', ({global, context}) => { global.number_of_time_units = context.duration; global.time_units = context.units; } ),
  ]
};
